local L = AceLibrary("AceLocale-2.2"):new("Buffalo2")

Buffalo2.Default = {
    GetName = function(self)
        return L["No name available"]
    end,

    GetDescription = function(self)
        return L["No description available"]
    end,

    author = "?",

    growUpwards = false,
    growRight = false,
    growHorizontalFirst = false,
    rows = 4,
    cols = 3,
    xpad = 7,
    ypad = 15,
    scale = 1.0,
    xpos = 500,
    ypos = 500,
    maxIcons = 100,

    Comparator = function(container, buff1, buff2)
        return true
    end,

    ContainsBuff = function(container, buff)
        return false
    end,

    GetContainerAnchor = function(container)
        local point, relativeTo, relativePoint, xOffs, yOffs
        local buttonOffset = container.frame:GetEffectiveScale() * Buffalo2.BUTTON_SIZE / 2
        if(container.growUpwards) then
            if(container.growRight) then
              point = "BOTTOMLEFT"
              relativeTo = UIParent
              relativePoint = "BOTTOMLEFT"
              xOffs = container.xpos - buttonOffset
              yOffs = container.ypos - buttonOffset
            else
              point = "BOTTOMRIGHT"
              relativeTo = UIParent
              relativePoint = "BOTTOMLEFT"
              xOffs = container.xpos + buttonOffset
              yOffs = container.ypos - buttonOffset
            end
        else
            if(container.growRight) then
              point = "TOPLEFT"
              relativeTo = UIParent
              relativePoint = "BOTTOMLEFT"
              xOffs = container.xpos - buttonOffset
              yOffs = container.ypos + buttonOffset
            else
              point = "TOPRIGHT"
              relativeTo = UIParent
              relativePoint = "BOTTOMLEFT"
              xOffs = container.xpos + buttonOffset
              yOffs = container.ypos + buttonOffset
            end
        end
                            
        return point, relativeTo, relativePoint, xOffs, yOffs
    end,


    Buttons = {
        GetWeaponEnchantIcon = function(button, buff)
          if(buff.unitid == "MH") then
            return GetInventoryItemTexture("player", GetInventorySlotInfo("MainHandSlot"))
          elseif(buff.unitid == "OH") then
            return GetInventoryItemTexture("player", GetInventorySlotInfo("SecondaryHandSlot"))
          end
        end,

        OnButtonAdding = function(button)
        end,

        OnButtonRemoval = function(button)
        end,

        OnButtonClick = function(button, mousebutton)
        end,

        OnSetBuff = function(button, buff)
        end,

        GetTimerAnchor = function(button)
          local point, relativePoint, xOffs, yOffs
          point = "TOP"
          relativePoint = "BOTTOM"
          xOffs = 0
          yOffs = -2
          return point, relativePoint, xOffs, yOffs
        end,

        GetLabelAnchor = function(button)
          point = "BOTTOM"
          relativePoint = "TOP"
          xOffs = 0
          yOffs = 2
          return point, relativePoint, xOffs, yOffs
        end,

        GetDurationString = function(button, buff)
            if(not buff.timeLeft) then
                return ""
            end
            if(buff.timeLeft > 3600) then
                return Buffalo2.abacus:FormatDurationCondensed(buff.timeLeft, true, true)
            else
                return Buffalo2.abacus:FormatDurationCondensed(buff.timeLeft, true, false)
            end
        end,

        GetLabelString = function(button, buff)
            return ""
        end,
    
        GetGhostColor = function(button)
            return 1.0, 1.0, 1.0, 0.7
        end,
    }
}
