local aceOO = AceLibrary("AceOO-2.0")
Buffalo2_Vector = aceOO.Class()

function Buffalo2_Vector.prototype:init()
    Buffalo2_Vector.super.prototype.init(self)
        self.elements = {}
end

function Buffalo2_Vector.prototype:Add(value)
        self.elements[self:Size()+1] = value
end

function Buffalo2_Vector.prototype:AddAll(table)
        for k, v in pairs(table) do
                self:Add(v)
        end
end

function Buffalo2_Vector.prototype:Get(key)
        return self.elements[key]
end

function Buffalo2_Vector.prototype:Clear()
        self.elements = {}
end

function Buffalo2_Vector.prototype:Contains(value)
        for i, v in ipairs(self.elements) do
                if (v == value) then
                        return true
                end
        end
end

function Buffalo2_Vector.prototype:ContainsAll(table)
        local result = true
        for k, v in pairs(table) do
                result = result and self:Contains(v)
        end
        return result
end

function Buffalo2_Vector.prototype:IsEmpty()
        return (self:Size() == 0)
end

function Buffalo2_Vector.prototype:Iterator()
        return ipairs(self.elements)
end

function Buffalo2_Vector.prototype:Remove(key)
        self.elements[key] = nil
end

function Buffalo2_Vector.prototype:RemoveByValue(value)
        for i, v in ipairs(self.elements) do
                if (v == value) then
              Buffalo2:Debug("Removing")
                        return tremove(self.elements, i)
                end
        end
end


function Buffalo2_Vector.prototype:RemoveAll(table)
        for k, v in pairs(table) do
                self.RemoveByValue(v)
        end
end

function Buffalo2_Vector.prototype:RemoveLast()
  if(self:Size() == 0) then
    return
  end
  local element = self.elements[self:Size()]
  self.elements[self:Size()] = nil
  return element
end

-- function Buffalo2_Vector.prototype:RetainAll(table)
-- end

function Buffalo2_Vector.prototype:Size()
        return #self.elements
end

function Buffalo2_Vector.prototype:GetTable()
        return self.elements
end

function Buffalo2_Vector.prototype:Sort(Comparator)
        if(self.sorting) then return end
        self.sorting = true
    local sorted = true
    local n = #self.elements - 1
    repeat
        sorted = true
        for i=1, n  do
            if(not Comparator(self.elements[i], self.elements[i+1])) then
                self.elements[i], self.elements[i+1] = self.elements[i+1], self.elements[i]
                sorted = false
            end
        end
        n = n-1
    until(sorted)
    self.sorting = nil
end
