local L = AceLibrary("AceLocale-2.2"):new("Buffalo2")
MIN_ALPHA = 0.3
FLASH_START_TIME = 30
FLASH_TIME = 1.5

Buffalo2.Templates.BlizzardBuffs = {
    author = "Nimbal",
    growHorizontalFirst = true,
    growRight = false,
    growUpwards = false,
    cols = 8,
    xPad = 6,

    GetName = function(container)
        return "Blizzard - Buffs and Weapon Enchants"
    end,

    GetDescription = function(container)
        return L["Classic Blizzard Style - Combines player buffs with temporary weapon enchants"]
    end,

    ContainsBuff = function(container, buff)
        if(buff.unitid == "player" and buff.filter == "HELPFUL") then
            return true
        elseif(buff.unitid == "MH" or buff.unitid == "OH") then
            return true
        else
            return false
        end
    end,

    Comparator = function(container, buff1, buff2)
        if(buff2.unitid == "MH") then
            return false
        elseif(buff2.unitid == "OH" and buff1.unitid ~= "MH") then
            return false
        else
            return true
        end
    end,

    Buttons = {
        GetGhostColor = function(container)
            return 0.2, 0.7, 0.2, 0.7
        end,

        GetDurationString = function(button, buff)
              local duration = buff.timeLeft
            if(not duration) then
                return ""
            end
            return SecondsToTimeAbbrev(duration)
        end,

        Buffalo2_Minor_Tick = function(button)
          local timeLeft = button.buff:GetExactTimeLeft()
            if(timeLeft and timeLeft < FLASH_START_TIME) then
                local alpha = ((1 + MIN_ALPHA) + (1 - MIN_ALPHA)*cos(deg(2*3.14159/FLASH_TIME*(FLASH_START_TIME - timeLeft))))/2
                button:SetAlpha(alpha)
            else
                button:SetAlpha(1.0)
            end
        end,
    },
}

Buffalo2.Templates.BlizzardDebuffs = {
    author = "Nimbal",
    growHorizontalFirst = true,
    growRight = false,
    growUpwards = false,
    cols = 8,

    GetName = function(container)
        return "Blizzard - Debuffs"
    end,

    GetDescription = function(container)
        return L["Classic Blizzard Style - Displays player debuffs"]
    end,

    ContainsBuff = function(container, buff)
        if(buff.unitid == "player" and buff.filter=="HARMFUL") then
            return true
        else
            return false
        end
    end,

    Buttons = {
        GetGhostColor = function(button)
            return 0.7, 0.2, 0.2, 0.7
        end,

        GetDurationString = function(button, buff)
              local duration = buff.timeLeft
            if(not duration) then
                return ""
            end
            return SecondsToTimeAbbrev(duration)
        end,

        Buffalo2_Minor_Tick = function(button)
          local timeLeft = button.buff:GetExactTimeLeft()
            if(timeLeft and timeLeft < FLASH_START_TIME) then
                local alpha = ((1 + MIN_ALPHA) + (1 - MIN_ALPHA)*cos(deg(2*3.14159/FLASH_TIME*(FLASH_START_TIME - timeLeft))))/2
                button:SetAlpha(alpha)
            else
                button:SetAlpha(1.0)
            end
        end,
    },
}
