--------------------------------- Sandbox.lua ---------------------------------
local L = AceLibrary("AceLocale-2.2"):new("Buffalo2")

local function abbrev__index (self, key)
    local value = ""
    for c in key:gmatch("(%w)%w*") do
        value = value .. c
    end

    rawset(self, key, value)
    return value
end

local abbrev = setmetatable({}, { __index = abbrev__index })

Buffalo2.Templates.Sandbox = {
    GetName = function(container)
        return "Sandbox"
    end,

    GetDescription = function(container)
        return "Play around"
    end,

    author = "You",

    growUpwards = false,
    growRight = false,
    growHorizontalFirst = false,
    rows = 4,
    cols = 3,
    xpad = 15,
    ypad = 15,
    scale = 1.0,
    xpos = 200,
    ypos = 200,

    ContainsBuff = function(container, buff)
        return buff.unitid == "player"
    end,
    
    Buttons = {
        GetGhostColor = function(button)
            return 1.0, 1.0, 1.0, 0.7
        end,

    OnButtonAdding = function(button)
      button.timertext:SetFontObject("GameFontNormalHuge")
    end,

        GetDurationString = function(button, buff)
          return "TEST"
--             if(not buff.timeLeft) then
--                 return ""
--             end
--             if(buff.timeLeft > 3600) then
--                 return Buffalo2.abacus:FormatDurationCondensed(buff.timeLeft, true, true)
--             else
--                 return Buffalo2.abacus:FormatDurationCondensed(buff.timeLeft, true, false)
--             end
        end,
    
        GetLabelString = function(button, buff)
            if(buff.unitid == "OH" or buff.unitid == "MH") then
                return buff.unitid
            end
            local name = buff.name
            return abbrev[name]
        end,
    },
}
